//
//  ActivityStyleKit.swift
//  ShowSomeProgress
//
//  Created by Alexander Kasimir on 06.08.19.
//  Copyright © 2019 Alexander Kasimir. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



import UIKit

public class ActivityStyleKit : NSObject {

    //// Drawing Methods

    @objc dynamic public class func drawOrbitIndicator(frame targetFrame: CGRect = CGRect(x: 0, y: 0, width: 78, height: 78), resizing: ResizingBehavior = .aspectFit, animationProgress: CGFloat = 0, progressColorRed: CGFloat = 0, progressColorGreen: CGFloat = 0.475, progressColorBlue: CGFloat = 1) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!
        
        //// Resize to Target Frame
        context.saveGState()
        let resizedFrame: CGRect = resizing.apply(rect: CGRect(x: 0, y: 0, width: 78, height: 78), target: targetFrame)
        context.translateBy(x: resizedFrame.minX, y: resizedFrame.minY)
        context.scaleBy(x: resizedFrame.width / 78, y: resizedFrame.height / 78)



        //// Variable Declarations
        let rotationOnce: CGFloat = 360 * animationProgress
        let rotationTwice: CGFloat = 360 * 2 * animationProgress
        let rotationThrice: CGFloat = 360 * 3 * animationProgress
        let progressBarColor = UIColor(red: progressColorRed, green: progressColorGreen, blue: progressColorBlue, alpha: 1)

        //// Outer Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationOnce * CGFloat.pi/180)

        let outerPath = UIBezierPath(ovalIn: CGRect(x: -3.57, y: -33.42, width: 7, height: 7))
        progressBarColor.setFill()
        outerPath.fill()

        context.restoreGState()


        //// Middle Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationTwice * CGFloat.pi/180)

        let middlePath = UIBezierPath(ovalIn: CGRect(x: -3.5, y: -23.5, width: 7, height: 7))
        progressBarColor.setFill()
        middlePath.fill()

        context.restoreGState()


        //// Inner Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationThrice * CGFloat.pi/180)

        let innerPath = UIBezierPath(ovalIn: CGRect(x: -3.5, y: -13.5, width: 7, height: 7))
        progressBarColor.setFill()
        innerPath.fill()

        context.restoreGState()


        //// Group
        //// OuterRing Drawing
        let outerRingPath = UIBezierPath(ovalIn: CGRect(x: 8.5, y: 8.5, width: 60, height: 60))
        progressBarColor.setStroke()
        outerRingPath.lineWidth = 1
        outerRingPath.stroke()


        //// MiddleRing Drawing
        let middleRingPath = UIBezierPath(ovalIn: CGRect(x: 18.5, y: 18.5, width: 40, height: 40))
        progressBarColor.setStroke()
        middleRingPath.lineWidth = 1
        middleRingPath.stroke()


        //// InnerRing Drawing
        let innerRingPath = UIBezierPath(ovalIn: CGRect(x: 28.5, y: 28.5, width: 20, height: 20))
        progressBarColor.setStroke()
        innerRingPath.lineWidth = 1
        innerRingPath.stroke()
        
        context.restoreGState()

    }

    @objc dynamic public class func drawOrbitIndicator2(frame targetFrame: CGRect = CGRect(x: 0, y: 0, width: 78, height: 78), resizing: ResizingBehavior = .aspectFit, animationProgress: CGFloat = 0, progressColorRed: CGFloat = 0, progressColorGreen: CGFloat = 0.475, progressColorBlue: CGFloat = 1) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!
        
        //// Resize to Target Frame
        context.saveGState()
        let resizedFrame: CGRect = resizing.apply(rect: CGRect(x: 0, y: 0, width: 78, height: 78), target: targetFrame)
        context.translateBy(x: resizedFrame.minX, y: resizedFrame.minY)
        context.scaleBy(x: resizedFrame.width / 78, y: resizedFrame.height / 78)



        //// Variable Declarations
        let rotationOnce: CGFloat = 360 * animationProgress
        let rotationTwice: CGFloat = 360 * 2 * animationProgress
        let rotationThrice: CGFloat = 360 * 3 * animationProgress
        let progressBarColor = UIColor(red: progressColorRed, green: progressColorGreen, blue: progressColorBlue, alpha: 1)

        //// Outer Drawing
        context.saveGState()
        context.translateBy(x: 39.01, y: 38.89)
        context.rotate(by: -rotationOnce * CGFloat.pi/180)

        let outerPath = UIBezierPath(ovalIn: CGRect(x: -3.52, y: -36.26, width: 7, height: 7))
        progressBarColor.setFill()
        outerPath.fill()

        context.restoreGState()


        //// Inner Drawing
        context.saveGState()
        context.translateBy(x: 39.01, y: 38.89)
        context.rotate(by: -rotationThrice * CGFloat.pi/180)

        let innerPath = UIBezierPath(ovalIn: CGRect(x: -2.51, y: -14.52, width: 5, height: 5))
        progressBarColor.setFill()
        innerPath.fill()

        context.restoreGState()


        //// Group 2
        context.saveGState()
        context.translateBy(x: 39.01, y: 38.89)
        context.rotate(by: -rotationTwice * CGFloat.pi/180)



        //// Middle Drawing
        context.saveGState()
        context.translateBy(x: 0.02, y: -0.26)
        context.rotate(by: -720 * CGFloat.pi/180)

        let middlePath = UIBezierPath(ovalIn: CGRect(x: -2.5, y: -22.5, width: 5, height: 5))
        progressBarColor.setFill()
        middlePath.fill()

        context.restoreGState()


        //// Moon Drawing
        context.saveGState()
        context.translateBy(x: 0.1, y: -20.38)
        context.rotate(by: -rotationThrice * CGFloat.pi/180)

        let moonPath = UIBezierPath(ovalIn: CGRect(x: -1.14, y: -5.47, width: 2, height: 2))
        progressBarColor.setFill()
        moonPath.fill()

        context.restoreGState()



        context.restoreGState()


        //// Center Drawing
        let centerPath = UIBezierPath(ovalIn: CGRect(x: 34.5, y: 34.5, width: 9, height: 9))
        progressBarColor.setFill()
        centerPath.fill()


        //// Group
        //// OuterRing Drawing
        let outerRingPath = UIBezierPath(ovalIn: CGRect(x: 5.9, y: 6.29, width: 66.12, height: 65.62))
        progressBarColor.setStroke()
        outerRingPath.lineWidth = 1
        outerRingPath.stroke()


        //// MiddleRing Drawing
        let middleRingPath = UIBezierPath(ovalIn: CGRect(x: 18.47, y: 18.66, width: 40.87, height: 40.87))
        progressBarColor.setStroke()
        middleRingPath.lineWidth = 1
        middleRingPath.stroke()


        //// InnerRing Drawing
        let innerRingPath = UIBezierPath(ovalIn: CGRect(x: 27, y: 27, width: 24, height: 24))
        progressBarColor.setStroke()
        innerRingPath.lineWidth = 1
        innerRingPath.stroke()
        
        context.restoreGState()

    }

    @objc dynamic public class func drawOrbitIndicator3(frame targetFrame: CGRect = CGRect(x: 0, y: 0, width: 78, height: 78), resizing: ResizingBehavior = .aspectFit, animationProgress: CGFloat = 0, progressColorRed: CGFloat = 0, progressColorGreen: CGFloat = 0.475, progressColorBlue: CGFloat = 1) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!
        
        //// Resize to Target Frame
        context.saveGState()
        let resizedFrame: CGRect = resizing.apply(rect: CGRect(x: 0, y: 0, width: 78, height: 78), target: targetFrame)
        context.translateBy(x: resizedFrame.minX, y: resizedFrame.minY)
        context.scaleBy(x: resizedFrame.width / 78, y: resizedFrame.height / 78)



        //// Variable Declarations
        let rotationOnce: CGFloat = 360 * animationProgress
        let rotationTwice: CGFloat = 360 * 2 * animationProgress
        let rotationThrice: CGFloat = 360 * 3 * animationProgress
        let progressBarColor = UIColor(red: progressColorRed, green: progressColorGreen, blue: progressColorBlue, alpha: 1)

        //// OuterRing Drawing
        let outerRingPath = UIBezierPath(ovalIn: CGRect(x: 9, y: 8.5, width: 60, height: 60))
        progressBarColor.setStroke()
        outerRingPath.lineWidth = 2
        outerRingPath.stroke()


        //// Outer Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationOnce * CGFloat.pi/180)

        let outerPath = UIBezierPath(ovalIn: CGRect(x: -2.78, y: -33.3, width: 7, height: 7))
        progressBarColor.setFill()
        outerPath.fill()

        context.restoreGState()


        //// Outer 2 Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationTwice * CGFloat.pi/180)

        let outer2Path = UIBezierPath(ovalIn: CGRect(x: -2.78, y: -33.3, width: 7, height: 7))
        progressBarColor.setFill()
        outer2Path.fill()

        context.restoreGState()


        //// Outer 3 Drawing
        context.saveGState()
        context.translateBy(x: 38.5, y: 38.5)
        context.rotate(by: -rotationThrice * CGFloat.pi/180)

        let outer3Path = UIBezierPath(ovalIn: CGRect(x: -2.78, y: -33.3, width: 7, height: 7))
        progressBarColor.setFill()
        outer3Path.fill()

        context.restoreGState()
        
        context.restoreGState()

    }

    @objc dynamic public class func drawTripleGears(frame targetFrame: CGRect = CGRect(x: 0, y: 0, width: 168, height: 177), resizing: ResizingBehavior = .aspectFit, animationProgress: CGFloat = 0, progressColorRed: CGFloat = 0, progressColorGreen: CGFloat = 0.475, progressColorBlue: CGFloat = 1) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!
        
        //// Resize to Target Frame
        context.saveGState()
        let resizedFrame: CGRect = resizing.apply(rect: CGRect(x: 0, y: 0, width: 168, height: 177), target: targetFrame)
        context.translateBy(x: resizedFrame.minX, y: resizedFrame.minY)
        context.scaleBy(x: resizedFrame.width / 168, y: resizedFrame.height / 177)



        //// Variable Declarations
        let gear1Rotation: CGFloat = animationProgress * 360 * 2
        let gear2Rotation: CGFloat = -(animationProgress * 360)
        let progressBarColor = UIColor(red: progressColorRed, green: progressColorGreen, blue: progressColorBlue, alpha: 1)
        let lightProgressBarColor = UIColor(red: progressColorRed + 0.2, green: progressColorGreen + 0.2, blue: progressColorBlue + 0.2, alpha: 1)

        //// Small Top Gear Drawing
        context.saveGState()
        context.translateBy(x: 36.02, y: 38.27)
        context.rotate(by: -gear1Rotation * CGFloat.pi/180)

        let smallTopGearPath = UIBezierPath()
        smallTopGearPath.move(to: CGPoint(x: -2.49, y: -33.46))
        smallTopGearPath.addCurve(to: CGPoint(x: 3.07, y: -24.18), controlPoint1: CGPoint(x: -2.5, y: -33.47), controlPoint2: CGPoint(x: 3.02, y: -28.06))
        smallTopGearPath.addCurve(to: CGPoint(x: 2.24, y: -18.71), controlPoint1: CGPoint(x: 3.09, y: -22.77), controlPoint2: CGPoint(x: 2.57, y: -20.17))
        smallTopGearPath.addCurve(to: CGPoint(x: 8.37, y: -16.87), controlPoint1: CGPoint(x: 4.37, y: -18.45), controlPoint2: CGPoint(x: 6.44, y: -17.83))
        smallTopGearPath.addCurve(to: CGPoint(x: 11.63, y: -22.88), controlPoint1: CGPoint(x: 8.86, y: -18.34), controlPoint2: CGPoint(x: 10.05, y: -21.52))
        smallTopGearPath.addCurve(to: CGPoint(x: 20.66, y: -26.7), controlPoint1: CGPoint(x: 14.71, y: -25.57), controlPoint2: CGPoint(x: 20.66, y: -26.7))
        smallTopGearPath.addLine(to: CGPoint(x: 22.07, y: -25.28))
        smallTopGearPath.addCurve(to: CGPoint(x: 19.37, y: -14.8), controlPoint1: CGPoint(x: 22.07, y: -25.28), controlPoint2: CGPoint(x: 22.09, y: -17.55))
        smallTopGearPath.addCurve(to: CGPoint(x: 14.9, y: -11.55), controlPoint1: CGPoint(x: 18.38, y: -13.79), controlPoint2: CGPoint(x: 16.16, y: -12.34))
        smallTopGearPath.addCurve(to: CGPoint(x: 16.03, y: -9.92), controlPoint1: CGPoint(x: 15.3, y: -11.03), controlPoint2: CGPoint(x: 15.68, y: -10.49))
        smallTopGearPath.addCurve(to: CGPoint(x: 17.86, y: -6.1), controlPoint1: CGPoint(x: 16.8, y: -8.7), controlPoint2: CGPoint(x: 17.41, y: -7.42))
        smallTopGearPath.addCurve(to: CGPoint(x: 24.37, y: -8.06), controlPoint1: CGPoint(x: 19.27, y: -6.81), controlPoint2: CGPoint(x: 22.31, y: -8.19))
        smallTopGearPath.addCurve(to: CGPoint(x: 33.47, y: -4.41), controlPoint1: CGPoint(x: 28.45, y: -7.79), controlPoint2: CGPoint(x: 33.47, y: -4.41))
        smallTopGearPath.addLine(to: CGPoint(x: 33.47, y: -2.41))
        smallTopGearPath.addCurve(to: CGPoint(x: 24.17, y: 3.14), controlPoint1: CGPoint(x: 33.47, y: -2.41), controlPoint2: CGPoint(x: 28.05, y: 3.1))
        smallTopGearPath.addCurve(to: CGPoint(x: 18.79, y: 2.31), controlPoint1: CGPoint(x: 22.78, y: 3.15), controlPoint2: CGPoint(x: 20.27, y: 2.64))
        smallTopGearPath.addCurve(to: CGPoint(x: 17.09, y: 8.3), controlPoint1: CGPoint(x: 18.56, y: 4.38), controlPoint2: CGPoint(x: 17.98, y: 6.41))
        smallTopGearPath.addCurve(to: CGPoint(x: 22.97, y: 11.46), controlPoint1: CGPoint(x: 18.62, y: 8.81), controlPoint2: CGPoint(x: 21.63, y: 9.95))
        smallTopGearPath.addCurve(to: CGPoint(x: 26.84, y: 20.47), controlPoint1: CGPoint(x: 25.67, y: 14.53), controlPoint2: CGPoint(x: 26.84, y: 20.47))
        smallTopGearPath.addLine(to: CGPoint(x: 25.44, y: 21.89))
        smallTopGearPath.addCurve(to: CGPoint(x: 14.94, y: 19.26), controlPoint1: CGPoint(x: 25.44, y: 21.89), controlPoint2: CGPoint(x: 17.71, y: 21.97))
        smallTopGearPath.addCurve(to: CGPoint(x: 11.78, y: 15.01), controlPoint1: CGPoint(x: 13.97, y: 18.33), controlPoint2: CGPoint(x: 12.6, y: 16.29))
        smallTopGearPath.addCurve(to: CGPoint(x: 9.98, y: 16.28), controlPoint1: CGPoint(x: 11.21, y: 15.46), controlPoint2: CGPoint(x: 10.61, y: 15.88))
        smallTopGearPath.addCurve(to: CGPoint(x: 6.26, y: 18.07), controlPoint1: CGPoint(x: 8.79, y: 17.02), controlPoint2: CGPoint(x: 7.54, y: 17.62))
        smallTopGearPath.addCurve(to: CGPoint(x: 8.12, y: 24.35), controlPoint1: CGPoint(x: 7, y: 19.56), controlPoint2: CGPoint(x: 8.24, y: 22.39))
        smallTopGearPath.addCurve(to: CGPoint(x: 4.49, y: 33.46), controlPoint1: CGPoint(x: 7.87, y: 28.43), controlPoint2: CGPoint(x: 4.49, y: 33.46))
        smallTopGearPath.addLine(to: CGPoint(x: 2.5, y: 33.47))
        smallTopGearPath.addCurve(to: CGPoint(x: -3.07, y: 24.18), controlPoint1: CGPoint(x: 2.5, y: 33.47), controlPoint2: CGPoint(x: -3.02, y: 28.06))
        smallTopGearPath.addCurve(to: CGPoint(x: -2.31, y: 19.03), controlPoint1: CGPoint(x: -3.09, y: 22.86), controlPoint2: CGPoint(x: -2.64, y: 20.52))
        smallTopGearPath.addCurve(to: CGPoint(x: -8.49, y: 17.21), controlPoint1: CGPoint(x: -4.45, y: 18.78), controlPoint2: CGPoint(x: -6.54, y: 18.16))
        smallTopGearPath.addCurve(to: CGPoint(x: -11.63, y: 22.88), controlPoint1: CGPoint(x: -9.03, y: 18.79), controlPoint2: CGPoint(x: -10.17, y: 21.61))
        smallTopGearPath.addCurve(to: CGPoint(x: -20.66, y: 26.7), controlPoint1: CGPoint(x: -14.71, y: 25.57), controlPoint2: CGPoint(x: -20.66, y: 26.7))
        smallTopGearPath.addLine(to: CGPoint(x: -22.07, y: 25.28))
        smallTopGearPath.addCurve(to: CGPoint(x: -19.37, y: 14.8), controlPoint1: CGPoint(x: -22.07, y: 25.28), controlPoint2: CGPoint(x: -22.09, y: 17.55))
        smallTopGearPath.addCurve(to: CGPoint(x: -15.18, y: 11.73), controlPoint1: CGPoint(x: -18.45, y: 13.86), controlPoint2: CGPoint(x: -16.47, y: 12.54))
        smallTopGearPath.addCurve(to: CGPoint(x: -16.22, y: 10.23), controlPoint1: CGPoint(x: -15.54, y: 11.25), controlPoint2: CGPoint(x: -15.89, y: 10.75))
        smallTopGearPath.addCurve(to: CGPoint(x: -18.11, y: 6.23), controlPoint1: CGPoint(x: -17.02, y: 8.94), controlPoint2: CGPoint(x: -17.65, y: 7.6))
        smallTopGearPath.addCurve(to: CGPoint(x: -24.37, y: 8.06), controlPoint1: CGPoint(x: -19.6, y: 6.96), controlPoint2: CGPoint(x: -22.42, y: 8.19))
        smallTopGearPath.addCurve(to: CGPoint(x: -33.47, y: 4.41), controlPoint1: CGPoint(x: -28.45, y: 7.79), controlPoint2: CGPoint(x: -33.47, y: 4.41))
        smallTopGearPath.addLine(to: CGPoint(x: -33.47, y: 2.41))
        smallTopGearPath.addCurve(to: CGPoint(x: -24.17, y: -3.14), controlPoint1: CGPoint(x: -33.47, y: 2.41), controlPoint2: CGPoint(x: -28.05, y: -3.1))
        smallTopGearPath.addCurve(to: CGPoint(x: -18.94, y: -2.34), controlPoint1: CGPoint(x: -22.83, y: -3.15), controlPoint2: CGPoint(x: -20.42, y: -2.67))
        smallTopGearPath.addCurve(to: CGPoint(x: -17.12, y: -8.31), controlPoint1: CGPoint(x: -18.66, y: -4.41), controlPoint2: CGPoint(x: -18.05, y: -6.43))
        smallTopGearPath.addCurve(to: CGPoint(x: -22.97, y: -11.46), controlPoint1: CGPoint(x: -18.66, y: -8.82), controlPoint2: CGPoint(x: -21.64, y: -9.96))
        smallTopGearPath.addCurve(to: CGPoint(x: -26.84, y: -20.47), controlPoint1: CGPoint(x: -25.67, y: -14.53), controlPoint2: CGPoint(x: -26.84, y: -20.47))
        smallTopGearPath.addCurve(to: CGPoint(x: -26.58, y: -20.74), controlPoint1: CGPoint(x: -26.84, y: -20.47), controlPoint2: CGPoint(x: -26.73, y: -20.58))
        smallTopGearPath.addCurve(to: CGPoint(x: -25.44, y: -21.89), controlPoint1: CGPoint(x: -26.17, y: -21.15), controlPoint2: CGPoint(x: -25.44, y: -21.89))
        smallTopGearPath.addCurve(to: CGPoint(x: -14.94, y: -19.27), controlPoint1: CGPoint(x: -25.44, y: -21.89), controlPoint2: CGPoint(x: -17.71, y: -21.97))
        smallTopGearPath.addCurve(to: CGPoint(x: -11.71, y: -14.9), controlPoint1: CGPoint(x: -13.94, y: -18.3), controlPoint2: CGPoint(x: -12.52, y: -16.17))
        smallTopGearPath.addCurve(to: CGPoint(x: -10.17, y: -15.97), controlPoint1: CGPoint(x: -11.22, y: -15.28), controlPoint2: CGPoint(x: -10.7, y: -15.64))
        smallTopGearPath.addCurve(to: CGPoint(x: -6.16, y: -17.87), controlPoint1: CGPoint(x: -8.88, y: -16.77), controlPoint2: CGPoint(x: -7.54, y: -17.41))
        smallTopGearPath.addCurve(to: CGPoint(x: -8.12, y: -24.35), controlPoint1: CGPoint(x: -6.87, y: -19.28), controlPoint2: CGPoint(x: -8.25, y: -22.3))
        smallTopGearPath.addCurve(to: CGPoint(x: -4.49, y: -33.46), controlPoint1: CGPoint(x: -7.87, y: -28.43), controlPoint2: CGPoint(x: -4.49, y: -33.46))
        smallTopGearPath.addLine(to: CGPoint(x: -2.5, y: -33.47))
        smallTopGearPath.addLine(to: CGPoint(x: -2.49, y: -33.46))
        smallTopGearPath.close()
        smallTopGearPath.move(to: CGPoint(x: 0, y: -10))
        smallTopGearPath.addCurve(to: CGPoint(x: -2.41, y: -9.71), controlPoint1: CGPoint(x: -0.83, y: -10), controlPoint2: CGPoint(x: -1.64, y: -9.9))
        smallTopGearPath.addCurve(to: CGPoint(x: -10, y: 0), controlPoint1: CGPoint(x: -6.77, y: -8.63), controlPoint2: CGPoint(x: -10, y: -4.69))
        smallTopGearPath.addCurve(to: CGPoint(x: 0, y: 10), controlPoint1: CGPoint(x: -10, y: 5.52), controlPoint2: CGPoint(x: -5.52, y: 10))
        smallTopGearPath.addCurve(to: CGPoint(x: 10, y: 0), controlPoint1: CGPoint(x: 5.52, y: 10), controlPoint2: CGPoint(x: 10, y: 5.52))
        smallTopGearPath.addCurve(to: CGPoint(x: 0, y: -10), controlPoint1: CGPoint(x: 10, y: -5.52), controlPoint2: CGPoint(x: 5.52, y: -10))
        smallTopGearPath.close()
        lightProgressBarColor.setFill()
        smallTopGearPath.fill()
        progressBarColor.setStroke()
        smallTopGearPath.lineWidth = 1.5
        smallTopGearPath.stroke()

        context.restoreGState()


        //// Small Bottom Gear Drawing
        context.saveGState()
        context.translateBy(x: 41.79, y: 139.2)
        context.rotate(by: -(gear1Rotation - 360) * CGFloat.pi/180)

        let smallBottomGearPath = UIBezierPath()
        smallBottomGearPath.move(to: CGPoint(x: -2.49, y: -33.46))
        smallBottomGearPath.addCurve(to: CGPoint(x: 3.07, y: -24.18), controlPoint1: CGPoint(x: -2.5, y: -33.47), controlPoint2: CGPoint(x: 3.02, y: -28.06))
        smallBottomGearPath.addCurve(to: CGPoint(x: 2.24, y: -18.71), controlPoint1: CGPoint(x: 3.09, y: -22.77), controlPoint2: CGPoint(x: 2.57, y: -20.17))
        smallBottomGearPath.addCurve(to: CGPoint(x: 8.37, y: -16.87), controlPoint1: CGPoint(x: 4.37, y: -18.45), controlPoint2: CGPoint(x: 6.44, y: -17.83))
        smallBottomGearPath.addCurve(to: CGPoint(x: 11.63, y: -22.88), controlPoint1: CGPoint(x: 8.86, y: -18.34), controlPoint2: CGPoint(x: 10.05, y: -21.52))
        smallBottomGearPath.addCurve(to: CGPoint(x: 20.66, y: -26.7), controlPoint1: CGPoint(x: 14.71, y: -25.57), controlPoint2: CGPoint(x: 20.66, y: -26.7))
        smallBottomGearPath.addLine(to: CGPoint(x: 22.07, y: -25.28))
        smallBottomGearPath.addCurve(to: CGPoint(x: 19.37, y: -14.8), controlPoint1: CGPoint(x: 22.07, y: -25.28), controlPoint2: CGPoint(x: 22.09, y: -17.55))
        smallBottomGearPath.addCurve(to: CGPoint(x: 14.9, y: -11.55), controlPoint1: CGPoint(x: 18.38, y: -13.79), controlPoint2: CGPoint(x: 16.16, y: -12.34))
        smallBottomGearPath.addCurve(to: CGPoint(x: 16.03, y: -9.92), controlPoint1: CGPoint(x: 15.3, y: -11.03), controlPoint2: CGPoint(x: 15.68, y: -10.49))
        smallBottomGearPath.addCurve(to: CGPoint(x: 17.86, y: -6.1), controlPoint1: CGPoint(x: 16.8, y: -8.7), controlPoint2: CGPoint(x: 17.41, y: -7.42))
        smallBottomGearPath.addCurve(to: CGPoint(x: 24.37, y: -8.06), controlPoint1: CGPoint(x: 19.27, y: -6.81), controlPoint2: CGPoint(x: 22.31, y: -8.19))
        smallBottomGearPath.addCurve(to: CGPoint(x: 33.47, y: -4.41), controlPoint1: CGPoint(x: 28.45, y: -7.79), controlPoint2: CGPoint(x: 33.47, y: -4.41))
        smallBottomGearPath.addLine(to: CGPoint(x: 33.47, y: -2.41))
        smallBottomGearPath.addCurve(to: CGPoint(x: 24.17, y: 3.14), controlPoint1: CGPoint(x: 33.47, y: -2.41), controlPoint2: CGPoint(x: 28.05, y: 3.1))
        smallBottomGearPath.addCurve(to: CGPoint(x: 18.79, y: 2.31), controlPoint1: CGPoint(x: 22.78, y: 3.15), controlPoint2: CGPoint(x: 20.27, y: 2.64))
        smallBottomGearPath.addCurve(to: CGPoint(x: 17.09, y: 8.3), controlPoint1: CGPoint(x: 18.56, y: 4.38), controlPoint2: CGPoint(x: 17.98, y: 6.41))
        smallBottomGearPath.addCurve(to: CGPoint(x: 22.97, y: 11.46), controlPoint1: CGPoint(x: 18.62, y: 8.81), controlPoint2: CGPoint(x: 21.63, y: 9.95))
        smallBottomGearPath.addCurve(to: CGPoint(x: 26.84, y: 20.47), controlPoint1: CGPoint(x: 25.67, y: 14.53), controlPoint2: CGPoint(x: 26.84, y: 20.47))
        smallBottomGearPath.addLine(to: CGPoint(x: 25.44, y: 21.89))
        smallBottomGearPath.addCurve(to: CGPoint(x: 14.94, y: 19.26), controlPoint1: CGPoint(x: 25.44, y: 21.89), controlPoint2: CGPoint(x: 17.71, y: 21.97))
        smallBottomGearPath.addCurve(to: CGPoint(x: 11.78, y: 15.01), controlPoint1: CGPoint(x: 13.97, y: 18.33), controlPoint2: CGPoint(x: 12.6, y: 16.29))
        smallBottomGearPath.addCurve(to: CGPoint(x: 9.98, y: 16.28), controlPoint1: CGPoint(x: 11.21, y: 15.46), controlPoint2: CGPoint(x: 10.61, y: 15.88))
        smallBottomGearPath.addCurve(to: CGPoint(x: 6.26, y: 18.07), controlPoint1: CGPoint(x: 8.79, y: 17.02), controlPoint2: CGPoint(x: 7.54, y: 17.62))
        smallBottomGearPath.addCurve(to: CGPoint(x: 8.12, y: 24.35), controlPoint1: CGPoint(x: 7, y: 19.56), controlPoint2: CGPoint(x: 8.24, y: 22.39))
        smallBottomGearPath.addCurve(to: CGPoint(x: 4.49, y: 33.46), controlPoint1: CGPoint(x: 7.87, y: 28.43), controlPoint2: CGPoint(x: 4.49, y: 33.46))
        smallBottomGearPath.addLine(to: CGPoint(x: 2.5, y: 33.47))
        smallBottomGearPath.addCurve(to: CGPoint(x: -3.07, y: 24.18), controlPoint1: CGPoint(x: 2.5, y: 33.47), controlPoint2: CGPoint(x: -3.02, y: 28.06))
        smallBottomGearPath.addCurve(to: CGPoint(x: -2.31, y: 19.03), controlPoint1: CGPoint(x: -3.09, y: 22.86), controlPoint2: CGPoint(x: -2.64, y: 20.52))
        smallBottomGearPath.addCurve(to: CGPoint(x: -8.49, y: 17.21), controlPoint1: CGPoint(x: -4.45, y: 18.78), controlPoint2: CGPoint(x: -6.54, y: 18.16))
        smallBottomGearPath.addCurve(to: CGPoint(x: -11.63, y: 22.88), controlPoint1: CGPoint(x: -9.03, y: 18.79), controlPoint2: CGPoint(x: -10.17, y: 21.61))
        smallBottomGearPath.addCurve(to: CGPoint(x: -20.66, y: 26.7), controlPoint1: CGPoint(x: -14.71, y: 25.57), controlPoint2: CGPoint(x: -20.66, y: 26.7))
        smallBottomGearPath.addLine(to: CGPoint(x: -22.07, y: 25.28))
        smallBottomGearPath.addCurve(to: CGPoint(x: -19.37, y: 14.8), controlPoint1: CGPoint(x: -22.07, y: 25.28), controlPoint2: CGPoint(x: -22.09, y: 17.55))
        smallBottomGearPath.addCurve(to: CGPoint(x: -15.18, y: 11.73), controlPoint1: CGPoint(x: -18.45, y: 13.86), controlPoint2: CGPoint(x: -16.47, y: 12.54))
        smallBottomGearPath.addCurve(to: CGPoint(x: -16.22, y: 10.23), controlPoint1: CGPoint(x: -15.54, y: 11.25), controlPoint2: CGPoint(x: -15.89, y: 10.75))
        smallBottomGearPath.addCurve(to: CGPoint(x: -18.11, y: 6.23), controlPoint1: CGPoint(x: -17.02, y: 8.94), controlPoint2: CGPoint(x: -17.65, y: 7.6))
        smallBottomGearPath.addCurve(to: CGPoint(x: -24.37, y: 8.06), controlPoint1: CGPoint(x: -19.6, y: 6.96), controlPoint2: CGPoint(x: -22.42, y: 8.19))
        smallBottomGearPath.addCurve(to: CGPoint(x: -33.47, y: 4.41), controlPoint1: CGPoint(x: -28.45, y: 7.79), controlPoint2: CGPoint(x: -33.47, y: 4.41))
        smallBottomGearPath.addLine(to: CGPoint(x: -33.47, y: 2.41))
        smallBottomGearPath.addCurve(to: CGPoint(x: -24.17, y: -3.14), controlPoint1: CGPoint(x: -33.47, y: 2.41), controlPoint2: CGPoint(x: -28.05, y: -3.1))
        smallBottomGearPath.addCurve(to: CGPoint(x: -18.94, y: -2.34), controlPoint1: CGPoint(x: -22.83, y: -3.15), controlPoint2: CGPoint(x: -20.42, y: -2.67))
        smallBottomGearPath.addCurve(to: CGPoint(x: -17.12, y: -8.31), controlPoint1: CGPoint(x: -18.66, y: -4.41), controlPoint2: CGPoint(x: -18.05, y: -6.43))
        smallBottomGearPath.addCurve(to: CGPoint(x: -22.97, y: -11.46), controlPoint1: CGPoint(x: -18.66, y: -8.82), controlPoint2: CGPoint(x: -21.64, y: -9.96))
        smallBottomGearPath.addCurve(to: CGPoint(x: -26.84, y: -20.47), controlPoint1: CGPoint(x: -25.67, y: -14.53), controlPoint2: CGPoint(x: -26.84, y: -20.47))
        smallBottomGearPath.addCurve(to: CGPoint(x: -26.58, y: -20.74), controlPoint1: CGPoint(x: -26.84, y: -20.47), controlPoint2: CGPoint(x: -26.73, y: -20.58))
        smallBottomGearPath.addCurve(to: CGPoint(x: -25.44, y: -21.89), controlPoint1: CGPoint(x: -26.17, y: -21.15), controlPoint2: CGPoint(x: -25.44, y: -21.89))
        smallBottomGearPath.addCurve(to: CGPoint(x: -14.94, y: -19.27), controlPoint1: CGPoint(x: -25.44, y: -21.89), controlPoint2: CGPoint(x: -17.71, y: -21.97))
        smallBottomGearPath.addCurve(to: CGPoint(x: -11.71, y: -14.9), controlPoint1: CGPoint(x: -13.94, y: -18.3), controlPoint2: CGPoint(x: -12.52, y: -16.17))
        smallBottomGearPath.addCurve(to: CGPoint(x: -10.17, y: -15.97), controlPoint1: CGPoint(x: -11.22, y: -15.28), controlPoint2: CGPoint(x: -10.7, y: -15.64))
        smallBottomGearPath.addCurve(to: CGPoint(x: -6.16, y: -17.87), controlPoint1: CGPoint(x: -8.88, y: -16.77), controlPoint2: CGPoint(x: -7.54, y: -17.41))
        smallBottomGearPath.addCurve(to: CGPoint(x: -8.12, y: -24.35), controlPoint1: CGPoint(x: -6.87, y: -19.28), controlPoint2: CGPoint(x: -8.25, y: -22.3))
        smallBottomGearPath.addCurve(to: CGPoint(x: -4.49, y: -33.46), controlPoint1: CGPoint(x: -7.87, y: -28.43), controlPoint2: CGPoint(x: -4.49, y: -33.46))
        smallBottomGearPath.addLine(to: CGPoint(x: -2.5, y: -33.47))
        smallBottomGearPath.addLine(to: CGPoint(x: -2.49, y: -33.46))
        smallBottomGearPath.close()
        smallBottomGearPath.move(to: CGPoint(x: 0, y: -10))
        smallBottomGearPath.addCurve(to: CGPoint(x: -2.41, y: -9.71), controlPoint1: CGPoint(x: -0.83, y: -10), controlPoint2: CGPoint(x: -1.64, y: -9.9))
        smallBottomGearPath.addCurve(to: CGPoint(x: -10, y: 0), controlPoint1: CGPoint(x: -6.77, y: -8.63), controlPoint2: CGPoint(x: -10, y: -4.69))
        smallBottomGearPath.addCurve(to: CGPoint(x: 0, y: 10), controlPoint1: CGPoint(x: -10, y: 5.52), controlPoint2: CGPoint(x: -5.52, y: 10))
        smallBottomGearPath.addCurve(to: CGPoint(x: 10, y: 0), controlPoint1: CGPoint(x: 5.52, y: 10), controlPoint2: CGPoint(x: 10, y: 5.52))
        smallBottomGearPath.addCurve(to: CGPoint(x: 0, y: -10), controlPoint1: CGPoint(x: 10, y: -5.52), controlPoint2: CGPoint(x: 5.52, y: -10))
        smallBottomGearPath.close()
        lightProgressBarColor.setFill()
        smallBottomGearPath.fill()
        progressBarColor.setStroke()
        smallBottomGearPath.lineWidth = 1.5
        smallBottomGearPath.stroke()

        context.restoreGState()


        //// Big Gear Drawing
        context.saveGState()
        context.translateBy(x: 104.86, y: 85.15)
        context.rotate(by: -gear2Rotation * CGFloat.pi/180)

        let bigGearPath = UIBezierPath()
        bigGearPath.move(to: CGPoint(x: 4.44, y: -51))
        bigGearPath.addCurve(to: CGPoint(x: 4.69, y: -45.99), controlPoint1: CGPoint(x: 4.86, y: -49.62), controlPoint2: CGPoint(x: 4.95, y: -47.74))
        bigGearPath.addCurve(to: CGPoint(x: 10.17, y: -45.08), controlPoint1: CGPoint(x: 6.55, y: -45.8), controlPoint2: CGPoint(x: 8.38, y: -45.49))
        bigGearPath.addCurve(to: CGPoint(x: 12.47, y: -50.32), controlPoint1: CGPoint(x: 10.37, y: -46.61), controlPoint2: CGPoint(x: 11.03, y: -48.7))
        bigGearPath.addCurve(to: CGPoint(x: 20.09, y: -57.19), controlPoint1: CGPoint(x: 15.05, y: -53.2), controlPoint2: CGPoint(x: 16.89, y: -55.29))
        bigGearPath.addLine(to: CGPoint(x: 22.36, y: -56.29))
        bigGearPath.addCurve(to: CGPoint(x: 23.42, y: -45.49), controlPoint1: CGPoint(x: 23.25, y: -52.48), controlPoint2: CGPoint(x: 23.7, y: -48.32))
        bigGearPath.addCurve(to: CGPoint(x: 21.72, y: -40.7), controlPoint1: CGPoint(x: 23.28, y: -44.04), controlPoint2: CGPoint(x: 22.64, y: -42.23))
        bigGearPath.addCurve(to: CGPoint(x: 26.6, y: -37.64), controlPoint1: CGPoint(x: 23.41, y: -39.78), controlPoint2: CGPoint(x: 25.04, y: -38.76))
        bigGearPath.addCurve(to: CGPoint(x: 30.77, y: -41.67), controlPoint1: CGPoint(x: 27.36, y: -38.99), controlPoint2: CGPoint(x: 28.78, y: -40.71))
        bigGearPath.addCurve(to: CGPoint(x: 40.44, y: -45.08), controlPoint1: CGPoint(x: 34.25, y: -43.34), controlPoint2: CGPoint(x: 36.75, y: -44.56))
        bigGearPath.addLine(to: CGPoint(x: 42.18, y: -43.37))
        bigGearPath.addCurve(to: CGPoint(x: 39.03, y: -32.99), controlPoint1: CGPoint(x: 41.55, y: -39.51), controlPoint2: CGPoint(x: 40.37, y: -35.5))
        bigGearPath.addCurve(to: CGPoint(x: 35.57, y: -29.18), controlPoint1: CGPoint(x: 38.34, y: -31.69), controlPoint2: CGPoint(x: 37.04, y: -30.25))
        bigGearPath.addCurve(to: CGPoint(x: 38.91, y: -24.51), controlPoint1: CGPoint(x: 36.78, y: -27.7), controlPoint2: CGPoint(x: 37.89, y: -26.14))
        bigGearPath.addCurve(to: CGPoint(x: 44.34, y: -26.66), controlPoint1: CGPoint(x: 40.13, y: -25.47), controlPoint2: CGPoint(x: 42.11, y: -26.54))
        bigGearPath.addCurve(to: CGPoint(x: 54.58, y: -26.1), controlPoint1: CGPoint(x: 48.2, y: -26.87), controlPoint2: CGPoint(x: 50.97, y: -27.03))
        bigGearPath.addLine(to: CGPoint(x: 55.54, y: -23.85))
        bigGearPath.addCurve(to: CGPoint(x: 48.66, y: -15.47), controlPoint1: CGPoint(x: 53.48, y: -20.52), controlPoint2: CGPoint(x: 50.85, y: -17.27))
        bigGearPath.addCurve(to: CGPoint(x: 43.98, y: -13.28), controlPoint1: CGPoint(x: 47.51, y: -14.52), controlPoint2: CGPoint(x: 45.74, y: -13.69))
        bigGearPath.addCurve(to: CGPoint(x: 45.27, y: -7.65), controlPoint1: CGPoint(x: 44.52, y: -11.44), controlPoint2: CGPoint(x: 44.96, y: -9.57))
        bigGearPath.addCurve(to: CGPoint(x: 51.15, y: -7.55), controlPoint1: CGPoint(x: 46.77, y: -8.07), controlPoint2: CGPoint(x: 49.02, y: -8.3))
        bigGearPath.addCurve(to: CGPoint(x: 60.38, y: -3.09), controlPoint1: CGPoint(x: 54.79, y: -6.26), controlPoint2: CGPoint(x: 57.41, y: -5.34))
        bigGearPath.addLine(to: CGPoint(x: 60.41, y: -0.64))
        bigGearPath.addCurve(to: CGPoint(x: 50.85, y: 4.45), controlPoint1: CGPoint(x: 57.23, y: 1.63), controlPoint2: CGPoint(x: 53.57, y: 3.62))
        bigGearPath.addCurve(to: CGPoint(x: 45.66, y: 4.66), controlPoint1: CGPoint(x: 49.42, y: 4.88), controlPoint2: CGPoint(x: 47.46, y: 4.96))
        bigGearPath.addCurve(to: CGPoint(x: 44.76, y: 10.18), controlPoint1: CGPoint(x: 45.47, y: 6.54), controlPoint2: CGPoint(x: 45.16, y: 8.38))
        bigGearPath.addCurve(to: CGPoint(x: 50.17, y: 12.51), controlPoint1: CGPoint(x: 46.3, y: 10.35), controlPoint2: CGPoint(x: 48.48, y: 11))
        bigGearPath.addCurve(to: CGPoint(x: 57.02, y: 20.15), controlPoint1: CGPoint(x: 53.05, y: 15.09), controlPoint2: CGPoint(x: 55.13, y: 16.94))
        bigGearPath.addLine(to: CGPoint(x: 56.12, y: 22.43))
        bigGearPath.addCurve(to: CGPoint(x: 45.35, y: 23.5), controlPoint1: CGPoint(x: 52.32, y: 23.33), controlPoint2: CGPoint(x: 48.18, y: 23.77))
        bigGearPath.addCurve(to: CGPoint(x: 40.46, y: 21.71), controlPoint1: CGPoint(x: 43.87, y: 23.35), controlPoint2: CGPoint(x: 42.01, y: 22.68))
        bigGearPath.addCurve(to: CGPoint(x: 37.42, y: 26.64), controlPoint1: CGPoint(x: 39.55, y: 23.42), controlPoint2: CGPoint(x: 38.53, y: 25.07))
        bigGearPath.addCurve(to: CGPoint(x: 41.53, y: 30.88), controlPoint1: CGPoint(x: 38.78, y: 27.39), controlPoint2: CGPoint(x: 40.55, y: 28.84))
        bigGearPath.addCurve(to: CGPoint(x: 44.93, y: 40.58), controlPoint1: CGPoint(x: 43.2, y: 34.37), controlPoint2: CGPoint(x: 44.41, y: 36.88))
        bigGearPath.addLine(to: CGPoint(x: 43.22, y: 42.33))
        bigGearPath.addCurve(to: CGPoint(x: 32.87, y: 39.17), controlPoint1: CGPoint(x: 39.37, y: 41.7), controlPoint2: CGPoint(x: 35.38, y: 40.51))
        bigGearPath.addCurve(to: CGPoint(x: 29.05, y: 35.65), controlPoint1: CGPoint(x: 31.56, y: 38.46), controlPoint2: CGPoint(x: 30.11, y: 37.13))
        bigGearPath.addCurve(to: CGPoint(x: 24.3, y: 39.08), controlPoint1: CGPoint(x: 27.54, y: 36.89), controlPoint2: CGPoint(x: 25.96, y: 38.03))
        bigGearPath.addCurve(to: CGPoint(x: 26.44, y: 44.56), controlPoint1: CGPoint(x: 25.26, y: 40.3), controlPoint2: CGPoint(x: 26.32, y: 42.31))
        bigGearPath.addCurve(to: CGPoint(x: 25.85, y: 54.82), controlPoint1: CGPoint(x: 26.64, y: 48.42), controlPoint2: CGPoint(x: 26.79, y: 51.21))
        bigGearPath.addLine(to: CGPoint(x: 23.6, y: 55.77))
        bigGearPath.addCurve(to: CGPoint(x: 15.27, y: 48.85), controlPoint1: CGPoint(x: 20.29, y: 53.7), controlPoint2: CGPoint(x: 17.06, y: 51.06))
        bigGearPath.addCurve(to: CGPoint(x: 13.11, y: 44.19), controlPoint1: CGPoint(x: 14.34, y: 47.71), controlPoint2: CGPoint(x: 13.52, y: 45.95))
        bigGearPath.addCurve(to: CGPoint(x: 7.64, y: 45.47), controlPoint1: CGPoint(x: 11.33, y: 44.72), controlPoint2: CGPoint(x: 9.5, y: 45.15))
        bigGearPath.addCurve(to: CGPoint(x: 7.52, y: 51.3), controlPoint1: CGPoint(x: 8.05, y: 46.97), controlPoint2: CGPoint(x: 8.26, y: 49.2))
        bigGearPath.addCurve(to: CGPoint(x: 3.08, y: 60.56), controlPoint1: CGPoint(x: 6.23, y: 54.95), controlPoint2: CGPoint(x: 5.32, y: 57.58))
        bigGearPath.addLine(to: CGPoint(x: 0.63, y: 60.59))
        bigGearPath.addCurve(to: CGPoint(x: -4.44, y: 51), controlPoint1: CGPoint(x: -1.64, y: 57.4), controlPoint2: CGPoint(x: -3.62, y: 53.73))
        bigGearPath.addCurve(to: CGPoint(x: -4.67, y: 45.92), controlPoint1: CGPoint(x: -4.86, y: 49.6), controlPoint2: CGPoint(x: -4.95, y: 47.69))
        bigGearPath.addCurve(to: CGPoint(x: -10.16, y: 45.04), controlPoint1: CGPoint(x: -6.54, y: 45.73), controlPoint2: CGPoint(x: -8.37, y: 45.44))
        bigGearPath.addCurve(to: CGPoint(x: -12.47, y: 50.32), controlPoint1: CGPoint(x: -10.36, y: 46.58), controlPoint2: CGPoint(x: -11.02, y: 48.68))
        bigGearPath.addCurve(to: CGPoint(x: -20.09, y: 57.19), controlPoint1: CGPoint(x: -15.05, y: 53.2), controlPoint2: CGPoint(x: -16.89, y: 55.29))
        bigGearPath.addLine(to: CGPoint(x: -22.36, y: 56.29))
        bigGearPath.addCurve(to: CGPoint(x: -23.42, y: 45.49), controlPoint1: CGPoint(x: -23.25, y: 52.48), controlPoint2: CGPoint(x: -23.7, y: 48.32))
        bigGearPath.addCurve(to: CGPoint(x: -21.75, y: 40.75), controlPoint1: CGPoint(x: -23.29, y: 44.05), controlPoint2: CGPoint(x: -22.66, y: 42.27))
        bigGearPath.addCurve(to: CGPoint(x: -26.65, y: 37.73), controlPoint1: CGPoint(x: -23.45, y: 39.84), controlPoint2: CGPoint(x: -25.08, y: 38.83))
        bigGearPath.addCurve(to: CGPoint(x: -30.77, y: 41.67), controlPoint1: CGPoint(x: -27.42, y: 39.06), controlPoint2: CGPoint(x: -28.82, y: 40.73))
        bigGearPath.addCurve(to: CGPoint(x: -40.44, y: 45.08), controlPoint1: CGPoint(x: -34.25, y: 43.34), controlPoint2: CGPoint(x: -36.75, y: 44.56))
        bigGearPath.addLine(to: CGPoint(x: -42.18, y: 43.37))
        bigGearPath.addCurve(to: CGPoint(x: -39.03, y: 32.99), controlPoint1: CGPoint(x: -41.55, y: 39.51), controlPoint2: CGPoint(x: -40.37, y: 35.5))
        bigGearPath.addCurve(to: CGPoint(x: -35.72, y: 29.29), controlPoint1: CGPoint(x: -38.36, y: 31.73), controlPoint2: CGPoint(x: -37.12, y: 30.34))
        bigGearPath.addCurve(to: CGPoint(x: -39.08, y: 24.64), controlPoint1: CGPoint(x: -36.93, y: 27.81), controlPoint2: CGPoint(x: -38.05, y: 26.26))
        bigGearPath.addCurve(to: CGPoint(x: -44.34, y: 26.66), controlPoint1: CGPoint(x: -40.31, y: 25.57), controlPoint2: CGPoint(x: -42.21, y: 26.54))
        bigGearPath.addCurve(to: CGPoint(x: -54.58, y: 26.1), controlPoint1: CGPoint(x: -48.2, y: 26.87), controlPoint2: CGPoint(x: -50.97, y: 27.03))
        bigGearPath.addLine(to: CGPoint(x: -55.54, y: 23.85))
        bigGearPath.addCurve(to: CGPoint(x: -48.66, y: 15.47), controlPoint1: CGPoint(x: -53.48, y: 20.52), controlPoint2: CGPoint(x: -50.85, y: 17.27))
        bigGearPath.addCurve(to: CGPoint(x: -44.24, y: 13.34), controlPoint1: CGPoint(x: -47.57, y: 14.57), controlPoint2: CGPoint(x: -45.92, y: 13.78))
        bigGearPath.addCurve(to: CGPoint(x: -45.56, y: 7.73), controlPoint1: CGPoint(x: -44.8, y: 11.52), controlPoint2: CGPoint(x: -45.24, y: 9.64))
        bigGearPath.addCurve(to: CGPoint(x: -51.15, y: 7.55), controlPoint1: CGPoint(x: -47.05, y: 8.1), controlPoint2: CGPoint(x: -49.16, y: 8.25))
        bigGearPath.addCurve(to: CGPoint(x: -60.38, y: 3.09), controlPoint1: CGPoint(x: -54.79, y: 6.26), controlPoint2: CGPoint(x: -57.41, y: 5.34))
        bigGearPath.addLine(to: CGPoint(x: -60.41, y: 0.64))
        bigGearPath.addCurve(to: CGPoint(x: -50.85, y: -4.45), controlPoint1: CGPoint(x: -57.23, y: -1.63), controlPoint2: CGPoint(x: -53.57, y: -3.62))
        bigGearPath.addCurve(to: CGPoint(x: -45.98, y: -4.71), controlPoint1: CGPoint(x: -49.51, y: -4.85), controlPoint2: CGPoint(x: -47.69, y: -4.95))
        bigGearPath.addCurve(to: CGPoint(x: -45.09, y: -10.22), controlPoint1: CGPoint(x: -45.8, y: -6.58), controlPoint2: CGPoint(x: -45.5, y: -8.42))
        bigGearPath.addCurve(to: CGPoint(x: -50.17, y: -12.51), controlPoint1: CGPoint(x: -46.61, y: -10.45), controlPoint2: CGPoint(x: -48.6, y: -11.11))
        bigGearPath.addCurve(to: CGPoint(x: -57.02, y: -20.15), controlPoint1: CGPoint(x: -53.05, y: -15.09), controlPoint2: CGPoint(x: -55.13, y: -16.94))
        bigGearPath.addLine(to: CGPoint(x: -56.12, y: -22.43))
        bigGearPath.addCurve(to: CGPoint(x: -45.35, y: -23.5), controlPoint1: CGPoint(x: -52.32, y: -23.33), controlPoint2: CGPoint(x: -48.18, y: -23.77))
        bigGearPath.addCurve(to: CGPoint(x: -40.75, y: -21.89), controlPoint1: CGPoint(x: -43.96, y: -23.36), controlPoint2: CGPoint(x: -42.24, y: -22.76))
        bigGearPath.addCurve(to: CGPoint(x: -37.7, y: -26.8), controlPoint1: CGPoint(x: -39.83, y: -23.59), controlPoint2: CGPoint(x: -38.82, y: -25.23))
        bigGearPath.addCurve(to: CGPoint(x: -41.53, y: -30.88), controlPoint1: CGPoint(x: -39.01, y: -27.59), controlPoint2: CGPoint(x: -40.61, y: -28.98))
        bigGearPath.addCurve(to: CGPoint(x: -44.93, y: -40.58), controlPoint1: CGPoint(x: -43.2, y: -34.37), controlPoint2: CGPoint(x: -44.41, y: -36.88))
        bigGearPath.addLine(to: CGPoint(x: -43.22, y: -42.33))
        bigGearPath.addCurve(to: CGPoint(x: -32.87, y: -39.17), controlPoint1: CGPoint(x: -39.37, y: -41.69), controlPoint2: CGPoint(x: -35.38, y: -40.51))
        bigGearPath.addCurve(to: CGPoint(x: -29.22, y: -35.88), controlPoint1: CGPoint(x: -31.63, y: -38.5), controlPoint2: CGPoint(x: -30.26, y: -37.27))
        bigGearPath.addCurve(to: CGPoint(x: -24.46, y: -39.29), controlPoint1: CGPoint(x: -27.71, y: -37.11), controlPoint2: CGPoint(x: -26.12, y: -38.25))
        bigGearPath.addCurve(to: CGPoint(x: -26.44, y: -44.56), controlPoint1: CGPoint(x: -25.37, y: -40.53), controlPoint2: CGPoint(x: -26.33, y: -42.43))
        bigGearPath.addCurve(to: CGPoint(x: -26.18, y: -53.36), controlPoint1: CGPoint(x: -26.61, y: -47.89), controlPoint2: CGPoint(x: -26.75, y: -50.42))
        bigGearPath.addCurve(to: CGPoint(x: -25.85, y: -54.82), controlPoint1: CGPoint(x: -26.09, y: -53.84), controlPoint2: CGPoint(x: -25.98, y: -54.32))
        bigGearPath.addLine(to: CGPoint(x: -23.6, y: -55.77))
        bigGearPath.addCurve(to: CGPoint(x: -15.4, y: -49.01), controlPoint1: CGPoint(x: -20.37, y: -53.75), controlPoint2: CGPoint(x: -17.22, y: -51.18))
        bigGearPath.addLine(to: CGPoint(x: -15.27, y: -48.85))
        bigGearPath.addCurve(to: CGPoint(x: -13.15, y: -44.38), controlPoint1: CGPoint(x: -14.37, y: -47.75), controlPoint2: CGPoint(x: -13.58, y: -46.07))
        bigGearPath.addCurve(to: CGPoint(x: -7.68, y: -45.63), controlPoint1: CGPoint(x: -11.37, y: -44.9), controlPoint2: CGPoint(x: -9.55, y: -45.32))
        bigGearPath.addCurve(to: CGPoint(x: -7.52, y: -51.3), controlPoint1: CGPoint(x: -8.06, y: -47.13), controlPoint2: CGPoint(x: -8.23, y: -49.27))
        bigGearPath.addCurve(to: CGPoint(x: -3.08, y: -60.56), controlPoint1: CGPoint(x: -6.23, y: -54.95), controlPoint2: CGPoint(x: -5.32, y: -57.58))
        bigGearPath.addLine(to: CGPoint(x: -0.63, y: -60.59))
        bigGearPath.addCurve(to: CGPoint(x: 4.44, y: -51), controlPoint1: CGPoint(x: 1.64, y: -57.4), controlPoint2: CGPoint(x: 3.62, y: -53.73))
        bigGearPath.close()
        bigGearPath.move(to: CGPoint(x: -10.72, y: -35.9))
        bigGearPath.addCurve(to: CGPoint(x: -37.38, y: 0), controlPoint1: CGPoint(x: -26.16, y: -31.27), controlPoint2: CGPoint(x: -37.38, y: -16.94))
        bigGearPath.addCurve(to: CGPoint(x: -36.33, y: 8.85), controlPoint1: CGPoint(x: -37.38, y: 3.05), controlPoint2: CGPoint(x: -37.02, y: 6.01))
        bigGearPath.addCurve(to: CGPoint(x: -36.27, y: 8.84), controlPoint1: CGPoint(x: -36.28, y: 8.88), controlPoint2: CGPoint(x: -36.27, y: 8.84))
        bigGearPath.addCurve(to: CGPoint(x: -30.89, y: 13.86), controlPoint1: CGPoint(x: -35.89, y: 9.75), controlPoint2: CGPoint(x: -33.47, y: 15.3))
        bigGearPath.addLine(to: CGPoint(x: -8.41, y: 0.84))
        bigGearPath.addCurve(to: CGPoint(x: -8.45, y: 0), controlPoint1: CGPoint(x: -8.44, y: 0.57), controlPoint2: CGPoint(x: -8.45, y: 0.28))
        bigGearPath.addCurve(to: CGPoint(x: -3.77, y: -7.59), controlPoint1: CGPoint(x: -8.45, y: -3.32), controlPoint2: CGPoint(x: -6.54, y: -6.2))
        bigGearPath.addLine(to: CGPoint(x: -3.77, y: -33.72))
        bigGearPath.addCurve(to: CGPoint(x: -10.77, y: -35.89), controlPoint1: CGPoint(x: -3.81, y: -36.8), controlPoint2: CGPoint(x: -10.3, y: -35.96))
        bigGearPath.addLine(to: CGPoint(x: -10.72, y: -35.9))
        bigGearPath.close()
        bigGearPath.move(to: CGPoint(x: 0, y: -4.5))
        bigGearPath.addCurve(to: CGPoint(x: -1.32, y: -4.3), controlPoint1: CGPoint(x: -0.46, y: -4.5), controlPoint2: CGPoint(x: -0.9, y: -4.43))
        bigGearPath.addCurve(to: CGPoint(x: -4.5, y: 0), controlPoint1: CGPoint(x: -3.16, y: -3.74), controlPoint2: CGPoint(x: -4.5, y: -2.03))
        bigGearPath.addCurve(to: CGPoint(x: 0, y: 4.5), controlPoint1: CGPoint(x: -4.5, y: 2.49), controlPoint2: CGPoint(x: -2.49, y: 4.5))
        bigGearPath.addCurve(to: CGPoint(x: 4.5, y: 0), controlPoint1: CGPoint(x: 2.49, y: 4.5), controlPoint2: CGPoint(x: 4.5, y: 2.49))
        bigGearPath.addCurve(to: CGPoint(x: 0, y: -4.5), controlPoint1: CGPoint(x: 4.5, y: -2.49), controlPoint2: CGPoint(x: 2.49, y: -4.5))
        bigGearPath.close()
        bigGearPath.move(to: CGPoint(x: 4.39, y: 7.24))
        bigGearPath.addCurve(to: CGPoint(x: 0, y: 8.48), controlPoint1: CGPoint(x: 3.11, y: 8.02), controlPoint2: CGPoint(x: 1.61, y: 8.48))
        bigGearPath.addCurve(to: CGPoint(x: -4.39, y: 7.24), controlPoint1: CGPoint(x: -1.61, y: 8.48), controlPoint2: CGPoint(x: -3.11, y: 8.02))
        bigGearPath.addLine(to: CGPoint(x: -27.12, y: 20.4))
        bigGearPath.addCurve(to: CGPoint(x: -25.87, y: 27.05), controlPoint1: CGPoint(x: -29.34, y: 21.73), controlPoint2: CGPoint(x: -26.88, y: 25.62))
        bigGearPath.addCurve(to: CGPoint(x: 0, y: 37.49), controlPoint1: CGPoint(x: -19.16, y: 33.52), controlPoint2: CGPoint(x: -10.04, y: 37.49))
        bigGearPath.addCurve(to: CGPoint(x: 25.88, y: 27.05), controlPoint1: CGPoint(x: 10.04, y: 37.49), controlPoint2: CGPoint(x: 19.16, y: 33.52))
        bigGearPath.addCurve(to: CGPoint(x: 27.13, y: 20.4), controlPoint1: CGPoint(x: 26.89, y: 25.62), controlPoint2: CGPoint(x: 29.34, y: 21.73))
        bigGearPath.addLine(to: CGPoint(x: 4.39, y: 7.24))
        bigGearPath.close()
        bigGearPath.move(to: CGPoint(x: 3.77, y: -33.72))
        bigGearPath.addLine(to: CGPoint(x: 3.77, y: -7.59))
        bigGearPath.addCurve(to: CGPoint(x: 8.45, y: 0), controlPoint1: CGPoint(x: 6.54, y: -6.2), controlPoint2: CGPoint(x: 8.45, y: -3.32))
        bigGearPath.addCurve(to: CGPoint(x: 8.41, y: 0.84), controlPoint1: CGPoint(x: 8.45, y: 0.28), controlPoint2: CGPoint(x: 8.44, y: 0.56))
        bigGearPath.addLine(to: CGPoint(x: 30.89, y: 13.85))
        bigGearPath.addCurve(to: CGPoint(x: 36.23, y: 8.93), controlPoint1: CGPoint(x: 33.47, y: 15.29), controlPoint2: CGPoint(x: 35.89, y: 9.75))
        bigGearPath.addCurve(to: CGPoint(x: 36.31, y: 8.96), controlPoint1: CGPoint(x: 36.27, y: 8.83), controlPoint2: CGPoint(x: 36.28, y: 8.88))
        bigGearPath.addCurve(to: CGPoint(x: 37.38, y: 0), controlPoint1: CGPoint(x: 37.02, y: 6.01), controlPoint2: CGPoint(x: 37.38, y: 3.05))
        bigGearPath.addCurve(to: CGPoint(x: 10.77, y: -35.91), controlPoint1: CGPoint(x: 37.38, y: -16.94), controlPoint2: CGPoint(x: 26.16, y: -31.27))
        bigGearPath.addCurve(to: CGPoint(x: 3.77, y: -33.72), controlPoint1: CGPoint(x: 10.3, y: -35.96), controlPoint2: CGPoint(x: 3.81, y: -36.8))
        bigGearPath.close()
        lightProgressBarColor.setFill()
        bigGearPath.fill()
        progressBarColor.setStroke()
        bigGearPath.lineWidth = 1.5
        bigGearPath.stroke()

        context.restoreGState()
        
        context.restoreGState()

    }




    @objc(ActivityStyleKitResizingBehavior)
    public enum ResizingBehavior: Int {
        case aspectFit /// The content is proportionally resized to fit into the target rectangle.
        case aspectFill /// The content is proportionally resized to completely fill the target rectangle.
        case stretch /// The content is stretched to match the entire target rectangle.
        case center /// The content is centered in the target rectangle, but it is NOT resized.

        public func apply(rect: CGRect, target: CGRect) -> CGRect {
            if rect == target || target == CGRect.zero {
                return rect
            }

            var scales = CGSize.zero
            scales.width = abs(target.width / rect.width)
            scales.height = abs(target.height / rect.height)

            switch self {
                case .aspectFit:
                    scales.width = min(scales.width, scales.height)
                    scales.height = scales.width
                case .aspectFill:
                    scales.width = max(scales.width, scales.height)
                    scales.height = scales.width
                case .stretch:
                    break
                case .center:
                    scales.width = 1
                    scales.height = 1
            }

            var result = rect.standardized
            result.size.width *= scales.width
            result.size.height *= scales.height
            result.origin.x = target.minX + (target.width - result.width) / 2
            result.origin.y = target.minY + (target.height - result.height) / 2
            return result
        }
    }
}
